/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package soutez1;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.control.ToggleButton;
import javafx.scene.image.Image;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.paint.Paint;
import javafx.stage.Stage;
import javafx.util.Duration;
import javafx.util.Pair;

/**
 *
 * @author soutez212
 */
public class Soutez1 extends Application {
    
    Pozice poz = new Pozice();
    double prisL;
    double prisR;
    Komunikator komunikator = null;
    
    public void kresli(GraphicsContext gc){
        gc.clearRect(0, 0, 205, 205);
        gc.setLineWidth(5);
        gc.strokeLine(prisL, 205, prisR, 205);
        gc.setFill(Color.RED);
        //Image image1 = new Image("file:lunar_lander.png", true);
        //gc.drawImage(image1, poz.x - 10, poz.y -10);
        gc.strokeRect(poz.x - 10 ,200 - poz.y - 10 , 20 ,20 );
        
    }
    
    @Override
    public void start(Stage primaryStage) {
        
        Label ladresa = new Label("Adresa:");
        TextField adresa = new TextField("localhost:8000");
        adresa.setPromptText("localhost:8000");
        
        Button ok = new Button("OK");
        
        GridPane setupRoot = new GridPane();
        
        setupRoot.add(ladresa, 0, 0);
        setupRoot.add(adresa, 1, 0);
        setupRoot.add(ok, 2, 0);
        
        Scene setup = new Scene(setupRoot, 300, 250);
        
        primaryStage.setTitle("212 Vít Skalický");
        primaryStage.setScene(setup);
        primaryStage.show();
        
        
        Label lx = new Label("X:");
        Label ly = new Label("Y:");
        Label lvx = new Label("Vx:");
        Label lvy = new Label("Vy:");
        Label lp = new Label("P:");
        Label ll = new Label("L:");
        Label lr = new Label("R:");
        Label lovladani = new Label("Ovládejte pomocí W,A,D");
        
        BorderPane root = new BorderPane();
        VBox vbox = new VBox();
        vbox.getChildren().addAll(lx,ly,lvx,lvy,lp,ll,lr,lovladani);
        
        HBox hbox = new HBox();
        ToggleButton bl = new ToggleButton("levý (A)");
        ToggleButton bup = new ToggleButton("prostřední (W)");
        ToggleButton br = new ToggleButton("pravý (D)");
        hbox.getChildren().addAll(bl,bup,br);
        
        root.setCenter(vbox);
        root.setBottom(hbox);
        
        Scene debug = new Scene(root);
        
        HBox konec = new HBox();
        Label klab = new Label();
        Button kBut = new Button("Znovu");
        konec.getChildren().addAll(klab,kBut);
        kBut.setOnAction(ev ->{
            primaryStage.setScene(setup);
        });
        
        Canvas canvas = new Canvas(200,205);
        GraphicsContext gc = canvas.getGraphicsContext2D();
        root.setLeft(canvas);
    
    
    
        
        
        KeyFrame updateDebug = new KeyFrame(Duration.millis(50), ev ->{
            try {
                poz = komunikator.komunikuj(bl.isSelected(),bup.isSelected(), br.isSelected());
            } catch (IOException ex) {
                Logger.getLogger(Soutez1.class.getName()).log(Level.SEVERE, null, ex);
            }
            if(poz == null){
                hbox.setDisable(true);
                vbox.setDisable(true);
                root.setTop(konec);
                if(komunikator.stav == 1) klab.setText("Krach!"); else klab.setText("Zdar!");
                
            }
            lx.setText("X:" + poz.x);
            if(poz.x - 10 < prisL || poz.x +10 > prisR) lx.setText(lx.getText() + " X" );
            ly.setText("Y:" + poz.y);
            lvx.setText("Vx:" + poz.vx);
            lvy.setText("Vy:" + poz.vy);
            lp.setText("P:" + poz.p);
            kresli(gc);
        });
        
        ok.setOnAction(ev -> {
            hbox.setDisable(false);
            vbox.setDisable(false);
            primaryStage.setScene(debug);
            root.setTop(null);
            komunikator = new Komunikator("http://" + adresa.getText());
            Pair<Double,Double> plocha = null;
            try {
                plocha = komunikator.start();   
            } catch (IOException ex) {
                Logger.getLogger(Soutez1.class.getName()).log(Level.SEVERE, null, ex);
            }
            prisL = plocha.getKey();
            prisR = plocha.getValue();
            ll.setText(prisL + "");
            lr.setText(prisR + "");
            Timeline plan = new Timeline(updateDebug);
            plan.setCycleCount(-1);
            plan.play();
        });
        
        /*debug.addEventHandler(KeyEvent.KEY_PRESSED, (key) -> {
      if(key.getCode()==KeyCode.ENTER) {
          System.out.println("You pressed enter");
      }
});*/
       
       
     debug.addEventHandler(KeyEvent.KEY_RELEASED, (key) -> {
      if(key.getCode()==KeyCode.W) {
          bup.setSelected(false);
          System.out.println("up release");
      }if(key.getCode()==KeyCode.A) {
          bl.setSelected(false);
      }if(key.getCode()==KeyCode.D) {
          br.setSelected(false);
      }
    });
     
       debug.addEventHandler(KeyEvent.KEY_PRESSED, (key) -> {
      if(key.getCode()==KeyCode.W) {
          bup.setSelected(true);
          System.out.println("up press");
      }if(key.getCode()==KeyCode.A) {
          bl.setSelected(true);
      }if(key.getCode()==KeyCode.D) {
          br.setSelected(true);
      }
           System.out.println("heeeey");
    });
   }
    
    
    

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
}
